;This is the library with API macroses
;Asper
;21.07.07 03:07

;forecolor dd 0x00FFFFFF
;backcolor dd 0x00000000

macro start_draw_window x,y,xsize,ysize,areacolor,caption,capsize
{
	mov	eax, 12 		; function 12:tell os about windowdraw
	mov	ebx, 1			; 1, start of draw
	int	0x40
	; DRAW WINDOW
	mov	eax, 0			; function 0 : define and draw window
	mov	ebx, x*65536+xsize	; [x start] *65536 + [x size]
	mov	ecx, y*65536+ysize	; [y start] *65536 + [y size]
	mov	edx,areacolor		; color of work area RRGGBB
	mov	esi,0x00334455		; color of grab bar  RRGGBB
	mov	edi,0x00ddeeff		; color of frames    RRGGBB
	int	0x40
	; WINDOW LABEL
	mov	eax, 4			; function 4 : write text to window
	mov	ebx, 8*65536+8		; [x start] *65536 + [y start]
	mov	ecx, 0x00ffffff 	; color of text RRGGBB
	mov	edx, caption		; pointer to text beginning
	mov	esi, capsize	; text length
	int	0x40
}

macro end_draw_window
{
	mov	eax, 12 		; end of redraw
	mov	ebx, 2
	int	0x40
}

macro draw_button x,y,xsize,ysize,id,butcolor,text,textlen,textcolor
{
	mov	eax, 8			; function 8 : define and draw button
	mov	ebx, (x)*65536+xsize	  ; [x start] *65536 + [x size]
	mov	ecx, (y)*65536+ysize	  ; [y start] *65536 + [y size]
	mov	edx, id 		; button id
	mov	esi, butcolor		; button color RRGGBB
	int	0x40

	mov	ebx, (x+5)*65536+y+(ysize-5)/2	; Draw button text
	mov	ecx, textcolor
	mov	edx, text
	xor	eax, eax
	mov	al,  textlen
	mov	esi, eax
	mov	eax, 4
	int	0x40
}

macro outtextxy x,y,prompt,prompt_len,color
{
	mov	ebx, x*65536+y	       ; draw info text with function 4
	mov	ecx, color
	mov	edx, prompt
	xor	eax, eax
	mov	al,  prompt_len
	mov	esi, eax
	mov	eax, 4
	int	0x40
}

;macro outnumberxy x,y;,num,num_len,color,radix
;{
;        mov     edx, x*65536+y         ; draw number with function 47
;
;        xor     ebx, ebx
;;        mov     bl,  0                 ; number in ecx
;;        mov     bh,  radix             ; radix of system
;;        shr     ebx, 8
;        mov     ebx, 000000000000001110000000000000b
;;        mov     eax, 10;num_len
;;        shr     eax, 16            ; bits 16-21 quantity of digits
;;        or      ebx, eax           ; to show
;
;        mov     edi, 0x00FFAA00
;        mov     ecx, 37;num
;        mov     esi, 01000000000111111111000000010001b;color
;        ;shr     esi, 4
;        ;or      esi, 0000b
;        mov     eax, 47
;        int     0x40
;}

;macro setforecolor col
;{
;  mov eax,col
;  mov [forecolor],eax
;}

;macro setbackcolor col
;{
;  mov [backcolor],col
;}

macro bar x,y,xsize,ysize,color
{
  mov eax, 13
  mov ebx, x*65536+xsize
  mov ecx, y*65536+ysize
  mov edx, color
  int 0x40
}

macro line x1,y1,x2,y2,color
{
  mov eax, 38
  mov ebx, x1*65536+x2
  mov ecx, y1*65536+y2
  mov edx, color
  int 0x40
}

macro rectangle x,y,xsize,ysize,color
{
  x2=x+xsize
  y2=y+ysize
  line x,y,x2,y,color
  line x,y,x,y2,color
  line x,y2,x2,y2,color
  line x2,y,x2,y2,color
}

macro putpixel x,y,color
{
  mov eax, 1
  mov ebx, x
  mov ecx, y
  mov edx, color
  int 0x40
}

macro circle x,y,radius,color
{
 @1:
  xx=x+rad
  yy=(y+rad)/xx
  putpixel xx,yy,color
}

